# -*- coding: utf-8 -*-
from mod_program import Iterator,Node_Condition
from dataModel import *
#====================================================================

class IsLeaf(Node_Condition):

#====================================================================
    CLS=ModelField(default="Atom")
    #-------------------------------------------------
    def onTest(self,node,**kwargs):

        if len(node.children.by_class(self.cls)) ==0:
            return True

    #-------------------------------------------------
#====================================================================

class IsBranch(Node_Condition):

#====================================================================
    CLS=ModelField(default="Atom")
    #------------------------------------------------
    def onTest(self,node,**kwargs):

        if len(node.children.by_class(self.cls)) !=0:
            return True

    #-------------------------------------------------
#===============================================================================

class Children(Iterator):
    
#===============================================================================
    #---------------------------------------------------------------------
    def onIter(self,node):

        return node.children

    #---------------------------------------------------------------------

#====================================================================

class All(Iterator):

#====================================================================

    #----------------------------------------------------------------

    def onIter(self,node):
        return node.all()


    #----------------------------------------------------------------
#====================================================================

class FirstDescendants(Iterator):

#====================================================================

    CLS=String()

    #----------------------------------------------------------------

    def onIter(self,node):
        return node.get_firsts(cls=self.cls,root=False)


    #----------------------------------------------------------------

#===============================================================================

class Root(Iterator):
    
#===============================================================================

    #---------------------------------------------------------------------
    def onIter(self,node):
        yield node.root
    #---------------------------------------------------------------------
#===============================================================================

class Parent(Iterator):
    
#===============================================================================

    #---------------------------------------------------------------------
    def onIter(self,node):
        if node.parent:
            yield node.parent
    #---------------------------------------------------------------------
#===============================================================================

class Ancestors(Iterator):

#===============================================================================
    #---------------------------------------------------------------------
    def onIter(self,node):

        return node.ancestors
    #---------------------------------------------------------------------
#===============================================================================

class Descendants(Iterator):
    
#===============================================================================

    #---------------------------------------------------------------------
    def onIter(self,node):

        return node.descendants

    #---------------------------------------------------------------------

#===============================================================================

class Level(Iterator):
    
#===============================================================================

    LEVEL=Integer()
    #---------------------------------------------------------------------
    def onIter(self,node):
        for elt in self.__recursiveIteration(node,0,self.level):
            yield elt
    #---------------------------------------------------------------------
    def __recursiveIteration(self,node,level,level_max):
        if level==level_max:
            yield node
        else:
            for elt in node.children:
                for elt2 in self.__recursiveIteration(elt,level+1,level_max):
                    yield elt2
    #---------------------------------------------------------------------
#===============================================================================

# LevelManager

#===============================================================================

class Tree_Levels(Iterator):

#===============================================================================

    #-------------------------------------------------

    def onIter(self,node):

        for level in range(node.depth()):
            yield level,TreeLevelHandlers_Iterator(selected_node=node,level=level)

    #---------------------------------------------------------------------

#===============================================================================

class DepthArea(Iterator):
    
#===============================================================================

    DEPTH=Integer()

    #---------------------------------------------------------------------
    def onIter(self,node):
        for elt in self.__recursiveIteration(node,self.deph):
            yield elt
    #---------------------------------------------------------------------
    def __recursiveIteration(self,node,level):

        yield node
        if level>0:
            for elt in node.children:
                for elt2 in self.__recursiveIteration(elt,level-1):
                    yield elt2

    #---------------------------------------------------------------------


#===============================================================================

class Tree_DepthAreas(Iterator):

#===============================================================================

    #---------------------------------------------------------------------
    def onIter(self,node):

        for level in range(node.depth()):
            yield level,Tree_DepthArea(deph=level,selected_node=node)


    #---------------------------------------------------------------------
#===============================================================================

class RangeArea(Iterator):

#===============================================================================


    DEPTH_MIN=Integer()
    DEPTH_MAX=Integer()

    #---------------------------------------------------------------------
    def onIter(self,node):

        for elt in self.__recursiveIteration(node,0,self.deph_min,self.deph_max):
            yield elt

    #---------------------------------------------------------------------
    def __recursiveIteration(self,node,level,deph_min,deph_max):
        if level>=deph_min:
            yield node
        if level<=deph_max-1:
            for elt in node.children:
                for elt2 in self.__recursiveIteration(elt,level+1,deph_min,deph_max):
                    yield elt2
    #---------------------------------------------------------------------


#===============================================================================


class Tree_RangeAreas(Iterator):

#===============================================================================

    #---------------------------------------------------------------------
    def onIter(self,node):

        deph=node.depht()
        div=int(deph/divisions)

        for level in range(divisions):
            deph_min,deph_max=level*div,level*(div+1)
            yield level,Tree_DepthArea(deph_min,deph_max,select=selected)
    #---------------------------------------------------------------------

#===============================================================================

class Select(Iterator):

#===============================================================================
    SRC=String(default=".")
    #---------------------------------------------------------------------
    def onIter(self,node):

        elt=node.find(self.src)
        if elt:
            yield elt
    #---------------------------------------------------------------------

#===============================================================================


